import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class Main {
  public static void main(String[] a) throws Exception {
    JPAUtil util = new JPAUtil();

    EntityManagerFactory emf = Persistence.createEntityManagerFactory("ProfessorService");
    EntityManager em = emf.createEntityManager();
    ProfessorService service = new ProfessorService(em);

    em.getTransaction().begin();

    Professor emp = service.createProfessor("empName",100);
    Department dept = service.createDepartment("deptName");

    emp = service.setProfessorDepartment(emp.getId(),dept.getId());
    System.out.println(emp.getDepartment() + " with Professors:");
    System.out.println(emp.getDepartment().getProfessors());

    Collection<Professor> emps = service.findAllProfessors();
    if (emps.isEmpty()) {
        System.out.println("No Professors found ");
    } else {
        System.out.println("Found Professors:");
        for (Professor emp1 : emps) {
            System.out.println(emp1);
        }
    }
    
    Collection<Department> depts = service.findAllDepartments();
    if (depts.isEmpty()) {
        System.out.println("No Departments found ");
    } else {
        System.out.println("Found Departments:");
        for (Department dept1 : depts) {
            System.out.println(dept1 + " with " + dept1.getProfessors().size() + " employees");
        }
    }



    util.checkData("select * from Professor");
    util.checkData("select * from Department");

    em.getTransaction().commit();
    em.close();
    emf.close();
  }
}